DeflateCompressorOutputStream
Date: 2017-02-08

org.apache.commons.compress.compressors.deflate

## Class DeflateCompressorOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - org.apache.commons.compress.compressors.CompressorOutputStream
    - - org.apache.commons.compress.compressors.deflate.DeflateCompressorOutputStream

- All Implemented Interfaces:
    java.io.Closeable, java.io.Flushable, java.lang.AutoCloseable

      public class DeflateCompressorOutputStream
      extends CompressorOutputStream

  Deflate compressor.
  Since:
    1.9

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DeflateCompressorOutputStream(java.io.OutputStream outputStream)` Creates a Deflate compressed output stream with the default parameters.
    `DeflateCompressorOutputStream(java.io.OutputStream outputStream, DeflateParameters parameters)` Creates a Deflate compressed output stream with the specified parameters.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()`
    `void` | `finish()` Finishes compression without closing the underlying stream.
    `void` | `flush()` Flushes the encoder and calls `outputStream.flush()`.
    `void` | `write(byte[] buf, int off, int len)`
    `void` | `write(int b)`

    - ### Methods inherited from class java.io.OutputStream

      `write`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DeflateCompressorOutputStream

          public DeflateCompressorOutputStream(java.io.OutputStream outputStream)
                                        throws java.io.IOException

      Creates a Deflate compressed output stream with the default parameters.
      Parameters:
        `outputStream` - the stream to wrap
      Throws:
        `java.io.IOException` - on error

    - #### DeflateCompressorOutputStream

          public DeflateCompressorOutputStream(java.io.OutputStream outputStream,
                                       DeflateParameters parameters)
                                        throws java.io.IOException

      Creates a Deflate compressed output stream with the specified parameters.
      Parameters:
        `outputStream` - the stream to wrap
        `parameters` - the deflate parameters to apply
      Throws:
        `java.io.IOException` - on error

  - ### Method Detail

    - #### write

          public void write(int b)
                     throws java.io.IOException

      Specified by:
        `write` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### write

          public void write(byte[] buf,
                   int off,
                   int len)
                     throws java.io.IOException

      Overrides:
        `write` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### flush

          public void flush()
                     throws java.io.IOException

      Flushes the encoder and calls `outputStream.flush()`. All buffered pending data will then be decompressible from the output stream. Calling this function very often may increase the compressed file size a lot.
      Specified by:
        `flush` in interface `java.io.Flushable`
      Overrides:
        `flush` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### finish

          public void finish()
                      throws java.io.IOException

      Finishes compression without closing the underlying stream.

      No more data can be written to this stream after finishing.

      Throws:
        `java.io.IOException` - on error

    - #### close

          public void close()
                     throws java.io.IOException

      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Overrides:
        `close` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`